(local {: contains} (require :lib.contains))
(local {: head} (require :lib.head))
(local {: tail} (require :lib.tail))

(lambda space-is-neighbor? [all-neighbors from to]
  ;; i have learned to check that i'm passing the correct type of move
  ;; i.e. a number and not a string
  (assert (= "number" (type from)) "from must be a number")
  (assert (= "number" (type to)) "to must be a number")
  (assert (= "table" (type all-neighbors)) "all-neighbors must be a table")

  (let [neighborhood-list (icollect [_ n (ipairs all-neighbors)] (if (= from (head n)) n))
        neighborhood (head neighborhood-list)
        neighbors (tail neighborhood)
        is-neighbor (contains neighbors to)]
    is-neighbor))

{: space-is-neighbor?}
